"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Variant(ProtocolElement):
    """
    The map of variants in the different assemblies
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import cva as cva_1_5_3

        return {
            "variants": cva_1_5_3.VariantRepresentation,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import cva as cva_1_5_3

        return {
            "org.gel.models.cva.avro.VariantRepresentation": cva_1_5_3.VariantRepresentation,
            "org.gel.models.cva.avro.Variant": cva_1_5_3.Variant,
        }

    __slots__ = [
        "id",
        "variants",
    ]

    def __init__(
        self,
        id,
        variants=list,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.Variant model.

        :param id:
            The id of the variant *
        :type id: str
        :param variants:
            A list of variant representations
        :type variants: list[VariantRepresentation]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
